{% extends 'discussions/base.html' %}
{% block title %}

{% endblock %}
{% block content %}

    <div class="container discussions-container">
        <div class="row">
            <div class="col-lg-4">
                <div class="discussion_list">
                    <div class="new-discussion-form border rounded p-3 mb-2">
                        <div class="">
                            <input type="text" id="tb-discussion-name" class="form-control"
                                   placeholder="Discussion Name"/>
                            <button id="btn-create-discussion" class="btn btn-primary mt-2">Create</button>
                        </div>
                    </div>
                    <div id="joined-discussions-list" class="joined-discussions border rounded">
                        <div class="alert alert-light text-center" role="alert">
                            You Have Not Joined Any Discussions.<br/>Join One!
                        </div>
                    </div>
                    <div id="available-discussions-list" class="available-discussions border rounded mt-2">
                        <div class="alert alert-light text-center" role="alert">
                            There are no Discussions Available.<br/>Create One!
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-lg-8">
                <div class="discussion ">
                    <div id="discussion-title" class="discussion-title">
                        {% if discussion %}
                            <h5> {{ discussion.title }}</h5>
                        {% else %}
                            <div class="alert alert-light" role="alert">
                                No discussion selected yet. Select One!
                            </div>
                        {% endif %}

                    </div>
                    <div class="discussion-from">
                        <div class="form-group">
                                <textarea id="message-content" class="form-control"
                                          placeholder="say something"></textarea>
                            <button id="btn-send-message" class="btn btn-primary mt-2">Send</button>
                        </div>
                    </div>
                    <div id="discussion-content" class="discussion-content">
                        {#                        <div class="alert alert-light text-center" role="alert">#}
                        {#                            No messages yet<br/>Send One!#}
                        {#                        </div>#}
                    </div>
                </div>
            </div>
        </div>
    </div>


    <script>
        {%  if discussion %}
            const fetchDiscussionMessages = () => {
                $.ajax({
                    method: 'POST',
                    url: '{% url "discussions:message" %}',
                    headers: {"X-CSRFToken": csrftoken},
                    data: {
                        action: 'list_discussion_messages',
                        discussion_id:{{ discussion.id }}
                    },
                    success: (data) => {
                        console.log(data);
                        if (data.error) {

                        } else {
                            $('#discussion-content').empty();
                            data.data.forEach(message => {
                                const messageView = createMessageComponent(message);
                                $('#discussion-content').append(messageView);
                            })
                        }
                    }

                });
            };




            const current_user = '{{ request.user.username }}';
            const discussion_owner = '{{ discussion_owner_username }}';
            const createMessageComponent = (message) => {
                const message_owner = document.createElement('a');
                $(message_owner).addClass('comment-owner');
                $(message_owner).attr('href', creatreUserProfileUrl(message.owner_username));
                $(message_owner).text(message.owner_username);

                const message_date = document.createElement('span');
                $(message_date).addClass('comment-date');
                $(message_date).text(`(${formateDate(new Date(message.timestamp))})`);

                const message_content = document.createElement('p');
                $(message_content).addClass('message-content');
                $(message_content).html(`${message_owner.outerHTML} ${message.content} ${message_date.outerHTML}`);

                const message_container = document.createElement('div');
                $(message_container).attr('id', 'message' + message.id);
                $(message_container).addClass('message-container');
                $(message_container).append(message_content);


                const message_owner_username = message.owner_username;
                if (current_user === discussion_owner || current_user === message_owner_username) {
                    const btn_delete = document.createElement('div');
                    $(btn_delete).addClass('btn-delete-message ml-2');
                    $(btn_delete).html('<i class="fas fa-trash-alt"></i>');
                    $(message_container).append(btn_delete);
                    $(btn_delete).on('click', () => {
                        $.ajax({
                            method: 'POST',
                            url: '{% url "discussions:message" %}',
                            headers: {"X-CSRFToken": csrftoken},
                            data: {action: 'delete', message_id: message.id},
                            success: (data) => {
                                console.log(data);
                                if (data.error) {

                                } else {
                                    $('#message' + message.id).remove();
                                }
                            }
                        });
                    });
                }


                return message_container;
            };



        {% endif %}



        const fetchJoinedDiscussions = () => {
            $.ajax({
                method: 'POST',
                url: '{% url "discussions:discussion" 1 %}',
                headers: {"X-CSRFToken": csrftoken},
                data: {
                    action: 'list_member_discussions',
                    username: '{{ request.user.username }}',
                    title: $('#tb-discussion-name').val()
                },
                success: (result) => {
                    console.log(result);
                    if (result.error) {

                    } else {
                        if (result.data) {
                            $('#joined-discussions-list').empty();
                            if (result.data.length === 0) {
                                $('#joined-discussions-list').html('<div class="alert alert-light text-center" role="alert">You Have Not Joined Any Discussions.<br/>Join One!</div>');
                            }

                            result.data.forEach(discussion => {
                                const container = document.createElement('div');
                                $(container).addClass('discussion-item-container p-2 m-2 border rounded');
                                const title = document.createElement('div');
                                $(title).addClass('discussion-item-title');
                                $(title).text(discussion.title);


                                const select_action = document.createElement('div');
                                $(select_action).addClass('btn-select-discussion');
                                $(select_action).html('<i class="fas fa-comments"></i>');
                                $(select_action).on('click', () => {
                                    window.location = creatreDiscussionUrl(discussion.id);
                                });

                                const leave_action = document.createElement('div');
                                $(leave_action).addClass('btn-leave-discussion');
                                $(leave_action).html('<i class="fas fa-sign-out-alt"></i>');

                                $(leave_action).on('click', () => {
                                    $.ajax({
                                        method: 'POST',
                                        url: '{% url "discussions:discussion" 1 %}',
                                        headers: {"X-CSRFToken": csrftoken},
                                        data: {
                                            action: 'leave_discussion',
                                            username: '{{ request.user.username }}',
                                            'discussion_id': discussion.id
                                        },
                                        success: (result) => {
                                            if (result.error) {

                                            } else {
                                                fetchJoinedDiscussions();
                                                fetchAvailableDiscussions();
                                            }
                                        }
                                    })
                                });

                                $(container).append(title);
                                $(container).append(leave_action);
                                $(container).append(select_action);
                                $('#joined-discussions-list').append(container);
                            })
                        }
                    }
                }
            });
        };
        const fetchAvailableDiscussions = () => {
            $.ajax({
                method: 'POST',
                url: '{% url "discussions:discussion" 1 %}',
                headers: {"X-CSRFToken": csrftoken},
                data: {action: 'list_discussions', username: '{{ request.user.username }}'},
                success: (result) => {
                    console.log(result);
                    if (result.error) {

                    } else {
                        if (result.data) {
                            $('#available-discussions-list').empty();
                            if (result.data.length === 0) {
                                $('#available-discussions-list').html(' <div class="alert alert-light text-center" role="alert">There are no Discussions Available.<br/>Create One!</div>')
                            }

                            result.data.forEach(discussion => {
                                const container = document.createElement('div');
                                $(container).addClass('discussion-item-container p-2 m-2 border rounded');
                                const title = document.createElement('div');
                                $(title).addClass('discussion-item-title');
                                $(title).text(discussion.title);
                                const join_action = document.createElement('div');
                                $(join_action).addClass('btn-join-discussion');
                                $(join_action).html('<i class="fas fa-sign-in-alt"></i>');

                                $(join_action).on('click', () => {
                                    $.ajax({
                                        method: 'POST',
                                        url: '{% url "discussions:discussion" 1 %}',
                                        headers: {"X-CSRFToken": csrftoken},
                                        data: {
                                            action: 'join_discussion',
                                            username: '{{ request.user.username }}',
                                            'discussion_id': discussion.id
                                        },
                                        success: (result) => {
                                            if (result.error) {

                                            } else {
                                                fetchJoinedDiscussions();
                                                fetchAvailableDiscussions();
                                            }
                                        }
                                    })
                                });

                                $(container).append(title);
                                $(container).append(join_action);
                                $('#available-discussions-list').append(container);
                            })
                        }
                    }
                }
            });
        };

        $(document).ready(() => {
            {%  if discussion %}
                fetchDiscussionMessages();
                window.setInterval(() => {
                    fetchDiscussionMessages();
                }, 5000);
            {% endif %}
            fetchJoinedDiscussions();
            fetchAvailableDiscussions();

            {%  if discussion %}
                $('#btn-send-message').on('click', () => {
                    $.ajax({
                        method: 'POST',
                        url: '{% url "discussions:message" %}',
                        headers: {"X-CSRFToken": csrftoken},
                        data: {
                            action: 'create',
                            username: '{{ request.user.username }}',
                            content: $('#message-content').val(),
                            discussion_id:{{ discussion.id }}
                        },
                        success: (data) => {
                            console.log(data);
                            $('#message-content').val('');
                            if (data.error) {

                            } else {
                                {#const message = createMessageComponent(data.data);#}
                                {#$('#discussion-content').append(message);#}
                                fetchDiscussionMessages();
                            }

                        }

                    })
                });
            {% else %}
                $('#btn-send-message').on('click', () => {
                    alert('You need to select a discussion');
                });
            {% endif %}


            $('#btn-create-discussion').on('click', (event) => {
                $.ajax({
                    method: 'POST',
                    url: '{% url "discussions:discussion" 1 %}',
                    headers: {"X-CSRFToken": csrftoken},
                    data: {
                        action: 'create',
                        username: '{{ request.user.username }}',
                        title: $('#tb-discussion-name').val()
                    },
                    success: (data) => {
                        console.log(data);
                        if (data.error) {

                        } else {
                            fetchJoinedDiscussions();
                            fetchAvailableDiscussions();
                        }

                    }
                });
            });
        });

    </script>

{% endblock %}